//ION

char *level;
char size_x = 23;
char size_y = 23;

int holetick=0,deadtick=0;

////////////////////////////////////////////////////////////////////////////////////////////////
// ION:: Draw Level Piece
////////////////////////////////////////////////////////////////////////////////////////////////
void ion_drw(int num, int x, char y){
	if(x>-16&&x<screenwidth+16&&y>-16&&y<screenheight+16){
		switch(num)
		{
			case 0: 
				Neo_Sprite16(x,y,12,floor_tile,virtual1);
				Neo_Sprite16(x,y,12,floor_tile+12,virtual2);
				break;
			case 1: 
				Neo_Sprite16m(x-3,y-3,16,wall_move+32,virtual1);
				Neo_Sprite16m(x-3,y-3,16,wall_move+32,virtual2);
				Neo_Sprite16(x-3,y-3,16,wall_move,virtual1);
				Neo_Sprite16(x-3,y-3,16,wall_move+16,virtual2);
				break;
			case 2: 
				Neo_Sprite16m(x-3,y-3,16,wall_hard+32,virtual1);
				Neo_Sprite16m(x-3,y-3,16,wall_hard+32,virtual2);
				Neo_Sprite16(x-3,y-3,16,wall_hard,virtual1);
				Neo_Sprite16(x-3,y-3,16,wall_hard+16,virtual2);
				break;
			case 3: 
				Neo_Sprite16(x,y,12,floor_tile,virtual1);
				Neo_Sprite16(x,y,12,floor_tile+12,virtual2);
				if(holemouse==0&&deadmouse==0) {
					Neo_Sprite16m(x,y,12,rodent+24,virtual1);
					Neo_Sprite16m(x,y,12,rodent+24,virtual2);
					Neo_Sprite16(x,y,12,rodent,virtual1);
					Neo_Sprite16(x,y,12,rodent+12,virtual2);}
				if(holemouse>0&&deadmouse==0) {
					Neo_Sprite16(x,y,12,rodent_fall+24*holemouse,virtual1);
					Neo_Sprite16(x,y,12,rodent_fall+24*holemouse+12,virtual2);if(holetick==40) {holemouse++;holetick=0;}
					if(holemouse==3) holemouse=0;}
				if(deadmouse>0) {
					Neo_Sprite16(x,y,12,rodent_dead+24*deadmouse,virtual1);
					Neo_Sprite16(x,y,12,rodent_dead+24*deadmouse+12,virtual2);if(deadtick==3) {deadmouse++;deadtick=0;}}

				break;
			case 4: 
				Neo_Sprite16(x,y,12,hole,virtual1);
				Neo_Sprite16(x,y,12,hole+12,virtual2);
				break;
			case 5: 
				Neo_Sprite16(x,y,12,floor_tile,virtual1);
				Neo_Sprite16(x,y,12,floor_tile+12,virtual2);
				Neo_Sprite16m(x,y,12,trap+24,virtual1);
				Neo_Sprite16m(x,y,12,trap+24,virtual2);
				Neo_Sprite16(x,y,12,trap,virtual1);
				Neo_Sprite16(x,y,12,trap+12,virtual2);
				break;
			case 6: 
				Neo_Sprite16(x,y,12,floor_tile,virtual1);
				Neo_Sprite16(x,y,12,floor_tile+12,virtual2);
				Neo_Sprite16m(x,y,12,cat+24,virtual1);
				Neo_Sprite16m(x,y,12,cat+24,virtual2);
				Neo_Sprite16(x,y,12,cat,virtual1);
				Neo_Sprite16(x,y,12,cat+12,virtual2);
				break;
			case 8: 
				Neo_Sprite16(x,y,12,floor_tile,virtual1);
				Neo_Sprite16(x,y,12,floor_tile+12,virtual2);
				Neo_Sprite16m(x,y,12,cheese+24,virtual1);
				Neo_Sprite16m(x,y,12,cheese+24,virtual2);
				Neo_Sprite16(x,y,12,cheese,virtual1);
				Neo_Sprite16(x,y,12,cheese+12,virtual2);
				break;
			case 10:
				Neo_Sprite16(x,y,12,floor_tile,virtual1);
				Neo_Sprite16(x,y,12,floor_tile+12,virtual2);
				Neo_Sprite16m(x,y,12,cat_trapped+24,virtual1);
				Neo_Sprite16m(x,y,12,cat_trapped+24,virtual2);
				Neo_Sprite16(x,y,12,cat_trapped,virtual1);
				Neo_Sprite16(x,y,12,cat_trapped+12,virtual2);
				break;
			case 40:
				Neo_Sprite16(x,y,12,wall_upleft,virtual1);
				Neo_Sprite16(x,y,12,wall_upleft+12,virtual2);
				break;
			case 41:
				Neo_Sprite16(x,y,12,wall_up,virtual1);
				Neo_Sprite16(x,y,12,wall_up+12,virtual2);
				break;
			case 42:
				Neo_Sprite16(x,y,12,wall_upright,virtual1);
				Neo_Sprite16(x,y,12,wall_upright+12,virtual2);
				break;
			case 43:
				Neo_Sprite16(x,y,12,wall_left,virtual1);
				Neo_Sprite16(x,y,12,wall_left+12,virtual2);
				break;
			case 44:
				Neo_Sprite16(x,y,12,wall_right,virtual1);
				Neo_Sprite16(x,y,12,wall_right+12,virtual2);
				break;
			case 45:
				Neo_Sprite16(x,y,12,wall_downleft,virtual1);
				Neo_Sprite16(x,y,12,wall_downleft+12,virtual2);
				break;
			case 46:
				Neo_Sprite16(x,y,12,wall_down,virtual1);
				Neo_Sprite16(x,y,12,wall_down+12,virtual2);
				break;
			case 47:
				Neo_Sprite16(x,y,12,wall_downright,virtual1);
				Neo_Sprite16(x,y,12,wall_downright+12,virtual2);
				break;
			case 48:
				Neo_Sprite16(x,y,12,wall_upleft_in,virtual1);
				Neo_Sprite16(x,y,12,wall_upleft_in+12,virtual2);
				break;
			case 49:
				Neo_Sprite16(x,y,12,wall_upright_in,virtual1);
				Neo_Sprite16(x,y,12,wall_upright_in+12,virtual2);
				break;
			case 50:
				Neo_Sprite16(x,y,12,wall_downleft_in,virtual1);
				Neo_Sprite16(x,y,12,wall_downleft_in+12,virtual2);
				break;
			case 51:
				Neo_Sprite16(x,y,12,wall_downright_in,virtual1);
				Neo_Sprite16(x,y,12,wall_downright_in+12,virtual2);
				break;

				

		}
	}
}



void ion_cycle(){
	int i,j;
	neo_next();
	holetick++;
	deadtick++;
	for (i = camera_x / 12 - 1; i < (camera_x + screenwidth) / 12 + 1; i++) {
	  for (j = camera_y / 12 - 1; j < (camera_y + screenheight) / 12 + 1; j++) {
			if(i>-1&&i<23&&j>-1&&j<23){
				ion_drw(levelprog[j][i], 
					(12 * (i - camera_x / 12)) - (camera_x % 12) + 12, 
					(12 * (j - camera_y / 12)) - (camera_y % 12));
			}
		}
	}
  if(holetick>40)holetick=0;
  if(deadtick>3)deadtick=0;
	neo_display();

}


